// 3́@Fu̐ɂsqx
// 񂲂̐Fo
//// Masayoshi Urushidani
//// Aitendo/Nissho OV7670 Camera &
//// Nokia 6100 LCD with Epson S1D15G00 Controller
//// for PIC18LF4620 in MC18, X=10MHz
//mu1231...change COMSCN for B4-LCD
//mu0102...ball color detect
//mu0114...ringo color detect
/****************** includes ********************/
#include <p18cxxx.h>
#include <delays.h>
#include <spi.h>
#include "sccb.h"

/***************** Type Defines ******************/
typedef unsigned char uchar;
typedef unsigned int uint;
typedef unsigned long ulong;
typedef unsigned char   byte;           // 8-bit
typedef unsigned int    word;           // 16-bit
typedef unsigned long   dword;          // 32-bit

/***************** Configuration **************/
#pragma config OSC = HSPLL		//HS
#pragma config WDT = OFF		//HW Disabled - SW Controlled
#pragma config PWRT = ON		//Power ON Reset enabled
#pragma config BOREN = OFF
#pragma config LVP = OFF
//#pragma config VREGEN = ON
#pragma config MCLRE = ON
#pragma config PBADEN = OFF		//PORTB<4:0> pins are configured as digital I/O on Reset 

#define c(x, y) cam_data(x,y); Delay10KTCYx(10);

#define LCD_RESET   LATCbits.LATC0		//PIN_C0
#define LCD_CS   	LATCbits.LATC1		//PIN_C1
#define SPI_CLK   	LATCbits.LATC3		//PIN_C3
//#define SPI_DI   	PORTCbits.RC4		//PIN_C4 		//unused
#define SPI_DO   	LATCbits.LATC5		//PIN_C5
#define RedLED		LATBbits.LATB1		//mu0102
#define	GrnLED		LATBbits.LATB2
#define	BluLED		LATBbits.LATB3
#define HREF		PORTBbits.RB4
#define	VSYNC		PORTBbits.RB5
#define	PCLK		PORTBbits.RB0

// Epson S1D15G00 Command Set
#define DISON  0xaf // 1. Display on P0
#define DISOFF 0xae // 2. Display off P0
#define DISINV 0xa7 // 4. Inverse display P0
#define COMSCN 0xbb // 5. Common scan direction P1
#define DISCTL 0xca // 6. Display control P4 (f[^V[gp.30P3͊ԈႢ)
#define SLPOUT 0x94 // 8. Sleep out P0
#define PASET  0x75 // 9. Page Address set P2
#define CASET  0x15 // 10.Column Address set P2
#define DATCTL 0xbc // 11.Data scan direction, etc. P3
#define RAMWR  0x5c // 13.Writing to memory P:data
#define OSCON  0xd1 // 21.Internal oscillation on P0
#define PWRCTR 0x20 // 23.Power control P1
#define VOLCTR 0x81 // 24.Electronic colume control P2
//add
#define RGBSET8     0xce
#define ENDPAGE 132
#define ENDCOL  130
#define _NOP   0x25

/* Registers */
#define REG_GAIN        0x00    /* Gain lower 8 bits (rest in vref) */
#define REG_BLUE        0x01    /* blue gain */
#define REG_RED         0x02    /* red gain */
#define REG_VREF        0x03    /* Pieces of GAIN, VSTART, VSTOP */
#define REG_COM1        0x04    /* Control 1 */
#define COM1_CCIR656    0x40    /* CCIR656 enable */
#define REG_BAVE        0x05    /* U/B Average level */
#define REG_GbAVE       0x06    /* Y/Gb Average level */
#define REG_AECHH       0x07    /* AEC MS 5 bits */
#define REG_RAVE        0x08    /* V/R Average level */
#define REG_COM2        0x09    /* Control 2 */
#define COM2_SSLEEP     0x10    /* Soft sleep mode */
#define REG_PID         0x0a    /* Product ID MSB */
#define REG_VER         0x0b    /* Product ID LSB */
#define REG_COM3        0x0c    /* Control 3 */
#define COM3_SWAP       0x40    /* Byte swap */
#define COM3_SCALEEN    0x08    /* Enable scaling */
#define COM3_DCWEN      0x04    /* Enable downsamp/crop/window */
#define REG_COM4        0x0d    /* Control 4 */
#define REG_COM5        0x0e    /* All "reserved" */
#define REG_COM6        0x0f    /* Control 6 */
#define REG_AECH        0x10    /* More bits of AEC value */
#define REG_CLKRC       0x11    /* Clocl control */
#define CLK_EXT         0x40    /* Use external clock directly */
#define CLK_SCALE       0x3f    /* Mask for internal clock scale */
#define REG_COM7        0x12    /* Control 7 */
#define COM7_RESET      0x80    /* Register reset */
#define COM7_FMT_MASK   0x38
#define COM7_FMT_VGA    0x00
#define COM7_FMT_CIF    0x20    /* CIF format */
#define COM7_FMT_QVGA   0x10    /* QVGA format */
#define COM7_FMT_QCIF   0x08    /* QCIF format */
#define COM7_RGB        0x04    /* bits 0 and 2 - RGB format */
#define COM7_YUV        0x00    /* YUV */
#define COM7_BAYER      0x01    /* Bayer format */
#define COM7_PBAYER     0x05    /* "Processed bayer" */
#define REG_COM8        0x13    /* Control 8 */
#define COM8_FASTAEC    0x80    /* Enable fast AGC/AEC */
#define COM8_AECSTEP    0x40    /* Unlimited AEC step size */
#define COM8_BFILT      0x20    /* Band filter enable */
#define COM8_AGC        0x04    /* Auto gain enable */
#define COM8_AWB        0x02    /* White balance enable */
#define COM8_AEC        0x01    /* Auto exposure enable */
#define REG_COM9        0x14    /* Control 9  - gain ceiling */
#define REG_COM10       0x15    /* Control 10 */
#define COM10_HSYNC     0x40    /* HSYNC instead of HREF */
#define COM10_PCLK_HB   0x20    /* Suppress PCLK on horiz blank */
#define COM10_HREF_REV  0x08    /* Reverse HREF */
#define COM10_VS_LEAD   0x04    /* VSYNC on clock leading edge */
#define COM10_VS_NEG    0x02    /* VSYNC negative */
#define COM10_HS_NEG    0x01    /* HSYNC negative */
#define REG_HSTART      0x17    /* Horiz start high bits */
#define REG_HSTOP       0x18    /* Horiz stop high bits */
#define REG_VSTART      0x19    /* Vert start high bits */
#define REG_VSTOP       0x1a    /* Vert stop high bits */
#define REG_PSHFT       0x1b    /* Pixel delay after HREF */
#define REG_MIDH        0x1c    /* Manuf. ID high */
#define REG_MIDL        0x1d    /* Manuf. ID low */
#define REG_MVFP        0x1e    /* Mirror / vflip */
#define MVFP_MIRROR     0x20    /* Mirror image */
#define MVFP_FLIP       0x10    /* Vertical flip */

#define REG_AEW         0x24    /* AGC upper limit */
#define REG_AEB         0x25    /* AGC lower limit */
#define REG_VPT         0x26    /* AGC/AEC fast mode op region */
#define REG_HSYST       0x30    /* HSYNC rising edge delay */
#define REG_HSYEN       0x31    /* HSYNC falling edge delay */
#define REG_HREF        0x32    /* HREF pieces */
#define REG_TSLB        0x3a    /* lots of stuff */
#define TSLB_YLAST      0x04    /* UYVY or VYUY - see com13 */
#define REG_COM11       0x3b    /* Control 11 */
#define COM11_NIGHT     0x80    /* NIght mode enable */
#define COM11_NMFR      0x60    /* Two bit NM frame rate */
#define COM11_HZAUTO    0x10    /* Auto detect 50/60 Hz */
#define COM11_50HZ      0x08    /* Manual 50Hz select */
#define COM11_EXP       0x02
#define REG_COM12       0x3c    /* Control 12 */
#define COM12_HREF      0x80    /* HREF always */
#define REG_COM13       0x3d    /* Control 13 */
#define COM13_GAMMA     0x80    /* Gamma enable */
#define COM13_UVSAT     0x40    /* UV saturation auto adjustment */
#define COM13_UVSWAP    0x01    /* V before U - w/TSLB */
#define REG_COM14       0x3e    /* Control 14 */
#define COM14_DCWEN     0x10    /* DCW/PCLK-scale enable */
#define REG_EDGE        0x3f    /* Edge enhancement factor */
#define REG_COM15       0x40    /* Control 15 */
#define COM15_R10F0     0x00    /* Data range 10 to F0 */
#define COM15_R01FE     0x80    /*            01 to FE */
#define COM15_R00FF     0xc0    /*            00 to FF */
#define COM15_RGB565    0x10    /* RGB565 output */
#define COM15_RGB555    0x30    /* RGB555 output */
#define REG_COM16       0x41    /* Control 16 */
#define COM16_AWBGAIN   0x08    /* AWB gain enable */
#define REG_COM17       0x42    /* Control 17 */
#define COM17_AECWIN    0xc0    /* AEC window - must match COM4 */
#define COM17_CBAR      0x08    /* DSP Color bar */

#define REG_CMATRIX_BASE 0x4f
#define CMATRIX_LEN 6
#define REG_CMATRIX_SIGN 0x58


#define REG_BRIGHT      0x55    /* Brightness */
#define REG_CONTRAS     0x56    /* Contrast control */

#define REG_GFIX        0x69    /* Fix gain control */

#define REG_REG76       0x76    /* OV's name */
#define R76_BLKPCOR     0x80    /* Black pixel correction enable */
#define R76_WHTPCOR     0x40    /* White pixel correction enable */

#define REG_RGB444      0x8c    /* RGB 444 control */
#define R444_ENABLE     0x02    /* Turn on RGB444, overrides 5x5 */
#define R444_RGBX       0x01    /* Empty nibble at end */

#define REG_HAECC1      0x9f    /* Hist AEC/AGC control 1 */
#define REG_HAECC2      0xa0    /* Hist AEC/AGC control 2 */

#define REG_BD50MAX     0xa5    /* 50hz banding step limit */
#define REG_HAECC3      0xa6    /* Hist AEC/AGC control 3 */
#define REG_HAECC4      0xa7    /* Hist AEC/AGC control 4 */
#define REG_HAECC5      0xa8    /* Hist AEC/AGC control 5 */
#define REG_HAECC6      0xa9    /* Hist AEC/AGC control 6 */
#define REG_HAECC7      0xaa    /* Hist AEC/AGC control 7 */
#define REG_BD60MAX     0xab    /* 60hz banding step limit */


/*************** Variables **************** */
#pragma udata
//static unsigned char pix_counter;
static unsigned int pix_counter;
static unsigned char line_counter;
static unsigned char sig_RG;
static unsigned char sig_BR;
static unsigned char sig_GB;
static unsigned char sig_XB;
static unsigned char sig_GR;
static unsigned char sig_XR;
static unsigned char sig_YB;
static unsigned char sig_RX;
static unsigned char sig_RB;
static unsigned char sig_XG;
static unsigned char sig_BG;
static unsigned char sig_BX;
static unsigned char sig_XY;
static unsigned char sig_GX;
static unsigned char sig_AX;
static unsigned char sig_R;
static unsigned char sig_G;
static unsigned char sig_B;
static unsigned char pcnt=0;
static unsigned char addr=0;
static unsigned char v_counter=0;				//mu1115

static unsigned int sum_R;						//mu0114
static unsigned int sum_G;
static unsigned int sum_B;

#pragma udata gpr3
static byte TXBuffer[256];
#pragma udata


#pragma code
// FUNCTION Prototypes
void main(void);
void InterruptHandlerHigh (void);
void spi_command(int);
void spi_data(int);
void ram_init(void);
void cam_init(void);
void led_out(unsigned char);

// S1D15G00/10windowݒ
void lcd_window(unsigned char x0, unsigned char y0, unsigned char x1, unsigned char y1)
{
   spi_command(CASET);
   spi_data(x0);
   spi_data(x1);
   spi_command(PASET);
   spi_data(y0 + 2);
   spi_data(y1 + 2);
}

// S1D15G00/10
void lcd_init(void)
{
    unsigned int i;

   // reset display
   SPI_CLK = 0;		
   SPI_DO = 0;		
   LCD_CS = 1;		
   LCD_RESET = 0;	
   Delay10KTCYx(5);	
   LCD_RESET = 1;	

   // S1D15G00̏
    spi_command(DISCTL);    // display control=0xca
    spi_data(3);        
    spi_data(32);       	// - 132line / 4 - 1 = 32 (31ɂ126C)
    spi_data(12);       
    spi_data(0);        	// - P4S1D15G00ɂ͂ȂB0:dispersion 1:non-dispersion
    
    spi_command(COMSCN);    // R̃XL=0xbb
    spi_data(1);			// - 1:168, 13269
    
    spi_command(OSCON);     // UON=0xd1
    Delay10KTCYx(5);
    
    spi_command(SLPOUT);    // sleep out=0x94
    
    spi_command(VOLCTR);    // dq{[=0x81
    spi_data(31);       	// RgXg
    spi_data(3);        	// - 3Œ

	spi_command(0x82);		//Temperature gradient
	spi_data(0x00);			//default value
    
    spi_command(PWRCTR);    // power control=0x20
    spi_data(15);       	// - 15Œ
    Delay10KTCYx(5);
    
    spi_command(0xa6);		//Normal display
    
    spi_command(DISINV);    // inverse display=0xa7 (0: - f:) display mode

	spi_command(0xa9);		//Partial area off
	
	spi_command(0x25);		//nop
    
    spi_command(DATCTL);    // data control=0xbc
    spi_data(0);			// - `
    spi_data(0);        
    spi_data(2);			//S1D16G00̃f[^V[gɂ͂Ȃ[h, 1:8bit grayscale, mu1103

    spi_command(PASET);		//0x75
    spi_data(0);
    spi_data(131);
    
    spi_command(CASET);     // SRAMNA=0x15
    spi_data(0);
    spi_data(131);
    
    //LcdCls();

    Delay10KTCYx(5);		

    spi_command(DISON);     // fBXvCON =0xaf
}

void main(void)				
{
    uint	i,j,k;			
    unsigned char data=0x55;

	ADCON1 = 0x0F;
	RCONbits.IPEN = 0;		// No priority
	OpenSPI(SPI_FOSC_4, MODE_00, SMPEND);

	TRISA = 0xC0;			// RA5...0=output,mu1227
	TRISB = 0b00110001;		//RB0=in=PCLK, RB2=R-LEd, RB3=Y-LED, RB4=in=HREF, RB5=in=VSYNC
	TRISC = 0b00000000;	
	TRISD = 0b11111111;		//all input
	TRISE = 0x00;			//mu1227
	PORTB = 0x00;		
	PORTC = 0x00011111;		//mu1203
	LATA  = 0;
	LATB  = 0;
	LATC  = 0x00011111;
	LATE  = 0;
	INTCON = 0b00011000;	//disable global and enable INT0/RB interrupt
	INTCON2 = 0b11000001;	//ext_int_edge(L_TO_H);

    lcd_init();

	ram_init();

	cam_init();
		data=cam_read(0x0a);
		led_out(data);

	INTCONbits.GIEH = 1;          //enable interrupts
	while(1){
		delay_100ms(10);
	}
}

//----------------------------------------------------------------------------
// High priority interrupt vector

#pragma code InterruptVectorHigh = 0x08
void
InterruptVectorHigh (void)
{
  _asm
    goto InterruptHandlerHigh //jump to interrupt routine
  _endasm
}

//----------------------------------------------------------------------------
// High priority interrupt routine

#pragma code
#pragma interrupt InterruptHandlerHigh

#define THR 70			//mu0114

void
InterruptHandlerHigh ()
{
  uint i;
  int j,k;

  if (INTCONbits.RBIF)
    {
        ////////INTCONbits.RBIF = 0;            //clear interrupt flag
		if(VSYNC){		//VSYNC edge?
			line_counter = 0;

			if(v_counter == 0) {
				RedLED = 1; GrnLED = 0; BluLED = 0;
				led_out(sum_R >>8);
			}
			if(v_counter == 1) {
				RedLED = 0; GrnLED = 1; BluLED = 0;
				led_out(sum_G >>8);
			}
			if(v_counter == 2) {
				RedLED = 0; GrnLED = 0; BluLED = 1;
				led_out(sum_B >>8);
			}
			++v_counter;
			if(v_counter > 2) v_counter = 0;
			sum_R = 0;
			sum_G = 0;
			sum_B = 0;
		}

		if(HREF){		//HREF edge?
			++line_counter;
			pix_counter = 0;
			addr = 0;
			pcnt=0;			//mu1130
			//red_counter=0;				//for test
		}
		if(!HREF && line_counter){
			//YelLED = 1;
			lcd_window(0, line_counter, 131, line_counter);
			spi_command(RAMWR);

/************************ region1 ************************/			
			if(line_counter>=0 && line_counter<=42) {
				for(j=0;j<64;){
						sig_RG=TXBuffer[j];
						sig_R = sig_R + (sig_RG >>4);
						sig_G = sig_G + (sig_RG & 0x0f);
						if( (3*sig_R + 6*sig_G + sig_B) > THR ) TXBuffer[j]=0x00;	//mu0114
						++j;
						//sum_R += sig_R;
						//sum_G += sig_G;

						sig_BR=TXBuffer[j];
						sig_B = sig_BR >>4;
						sig_R = sig_BR & 0x0f;
						if( (3*sig_R + 6*sig_G + sig_B) > THR ) TXBuffer[j]=0x00;	//mu0114
						++j;
						//sum_B += sig_B;			//mu0114
						//sum_R += sig_R;

						sig_GB=TXBuffer[j];
						sig_G = sig_GB >>4;
						sig_B = sig_B + (sig_GB & 0x0f);
						if( (3*sig_R + 6*sig_G + sig_B) > THR ) TXBuffer[j]=0x00;	//mu0114
						++j;
						//sum_G += sig_G;
						//sum_B += sig_B;
				}
			}
/************************ region2 ************************/			
			if(line_counter>=0 && line_counter<=42) {
				for(j=64;j<128;){
						sig_BR=TXBuffer[j];
						sig_B = sig_BR >>4;
						sig_R = sig_BR & 0x0f;
						if( (3*sig_R + 6*sig_G + sig_B) > THR ) TXBuffer[j]=0x00;	//mu0114
						++j;
						//sum_B += sig_B;			//mu0114
						//sum_R += sig_R;

						sig_GB=TXBuffer[j];
						sig_G = sig_GB >>4;
						sig_B = sig_B + (sig_GB & 0x0f);
						if( (3*sig_R + 6*sig_G + sig_B) > THR ) TXBuffer[j]=0x00;	//mu0114
						++j;
						//sum_G += sig_G;
						//sum_B += sig_B;

						sig_RG=TXBuffer[j];
						sig_R = sig_R + (sig_RG >>4);
						sig_G = sig_G + (sig_RG & 0x0f);
						if( (3*sig_R + 6*sig_G + sig_B) > THR ) TXBuffer[j]=0x00;	//mu0114
						++j;
						//sum_R += sig_R;
						//sum_G += sig_G;
				}
			}
/************************ region3 ************************/			
			if(line_counter>=0 && line_counter<=42) {
				for(j=128;j<192;){
						sig_GB=TXBuffer[j];
						sig_G = sig_GB >>4;
						sig_B = sig_B + (sig_GB & 0x0f);
						if( (3*sig_R + 6*sig_G + sig_B) > THR ) TXBuffer[j]=0x00;	//mu0114
						++j;
						//sum_G += sig_G;
						//sum_B += sig_B;
						sig_RG=TXBuffer[j];
						sig_R = sig_R + (sig_RG >>4);
						sig_G = sig_G + (sig_RG & 0x0f);
						if( (3*sig_R + 6*sig_G + sig_B) > THR ) TXBuffer[j]=0x00;	//mu0114
						++j;
						//sum_R += sig_R;
						//sum_G += sig_G;

						sig_BR=TXBuffer[j];
						sig_B = sig_BR >>4;
						sig_R = sig_BR & 0x0f;
						if( (3*sig_R + 6*sig_G + sig_B) > THR ) TXBuffer[j]=0x00;	//mu0114
						++j;
						//sum_B += sig_B;			//mu0114
						//sum_R += sig_R;
				}
			}
/************************ region4 ************************/			
			if(line_counter>42 && line_counter<=86) {
				for(j=0;j<64;){
						sig_RG=TXBuffer[j];
						sig_R = sig_R + (sig_RG >>4);
						sig_G = sig_G + (sig_RG & 0x0f);
						if( (3*sig_R + 6*sig_G + sig_B) > THR ) TXBuffer[j]=0x00;	//mu0114
						++j;
						//sum_R += sig_R;
						//sum_G += sig_G;

						sig_BR=TXBuffer[j];
						sig_B = sig_BR >>4;
						sig_R = sig_BR & 0x0f;
						if( (3*sig_R + 6*sig_G + sig_B) > THR ) TXBuffer[j]=0x00;	//mu0114
						++j;
						//sum_B += sig_B;			//mu0114
						//sum_R += sig_R;

						sig_GB=TXBuffer[j];
						sig_G = sig_GB >>4;
						sig_B = sig_B + (sig_GB & 0x0f);
						if( (3*sig_R + 6*sig_G + sig_B) > THR ) TXBuffer[j]=0x00;	//mu0114
						++j;
						//sum_G += sig_G;
						//sum_B += sig_B;
				}
			}
/************************ center/region5 ************************/			
			if(line_counter>42 && line_counter<86) {
				for(j=64;j<128;){
						sig_BR=TXBuffer[j];
						sig_B = sig_BR >>4;
						sig_R = sig_BR & 0x0f;
						if( (3*sig_R + 6*sig_G + sig_B) > THR ) TXBuffer[j]=0x00;	//mu0114
						else {						//mu0115
							sum_B += sig_B;			//mu0114
							sum_R += sig_R;
						}
						++j;

						sig_GB=TXBuffer[j];
						sig_G = sig_GB >>4;
						sig_B = sig_B + (sig_GB & 0x0f);
						if( (3*sig_R + 6*sig_G + sig_B) > THR ) TXBuffer[j]=0x00;	//mu0114
						else {						//mu0115
							sum_G += sig_G;
							sum_B += sig_B;
						}
						++j;

						sig_RG=TXBuffer[j];
						sig_R = sig_R + (sig_RG >>4);
						sig_G = sig_G + (sig_RG & 0x0f);
						if( (3*sig_R + 6*sig_G + sig_B) > THR ) TXBuffer[j]=0x00;	//mu0114
						else {
							sum_R += sig_R;
							sum_G += sig_G;
						}
						++j;
				}
			}
/************************ region6 ************************/			
			if(line_counter>42 && line_counter<86) {
				for(j=128;j<192;){
						sig_GB=TXBuffer[j];
						sig_G = sig_GB >>4;
						sig_B = sig_B + (sig_GB & 0x0f);
						if( (3*sig_R + 6*sig_G + sig_B) > THR ) TXBuffer[j]=0x00;	//mu0114
						++j;
						//sum_G += sig_G;
						//sum_B += sig_B;
						sig_RG=TXBuffer[j];
						sig_R = sig_R + (sig_RG >>4);
						sig_G = sig_G + (sig_RG & 0x0f);
						if( (3*sig_R + 6*sig_G + sig_B) > THR ) TXBuffer[j]=0x00;	//mu0114
						++j;
						//sum_R += sig_R;
						//sum_G += sig_G;

						sig_BR=TXBuffer[j];
						sig_B = sig_BR >>4;
						sig_R = sig_BR & 0x0f;
						if( (3*sig_R + 6*sig_G + sig_B) > THR ) TXBuffer[j]=0x00;	//mu0114
						++j;
						//sum_B += sig_B;			//mu0114
						//sum_R += sig_R;
				}
			}
/************************ region7 ************************/			
			if(line_counter>=86 && line_counter<128) {
				for(j=0;j<64;){
						sig_RG=TXBuffer[j];
						sig_R = sig_R + (sig_RG >>4);
						sig_G = sig_G + (sig_RG & 0x0f);
						if( (3*sig_R + 6*sig_G + sig_B) > THR ) TXBuffer[j]=0x00;	//mu0114
						++j;
						//sum_R += sig_R;
						//sum_G += sig_G;

						sig_BR=TXBuffer[j];
						sig_B = sig_BR >>4;
						sig_R = sig_BR & 0x0f;
						if( (3*sig_R + 6*sig_G + sig_B) > THR ) TXBuffer[j]=0x00;	//mu0114
						++j;
						//sum_B += sig_B;			//mu0114
						//sum_R += sig_R;

						sig_GB=TXBuffer[j];
						sig_G = sig_GB >>4;
						sig_B = sig_B + (sig_GB & 0x0f);
						if( (3*sig_R + 6*sig_G + sig_B) > THR ) TXBuffer[j]=0x00;	//mu0114
						++j;
						//sum_G += sig_G;
						//sum_B += sig_B;
				}
			}
/************************ region8 ************************/			
			if(line_counter>=86 && line_counter<128) {
				for(j=64;j<128;){
						sig_BR=TXBuffer[j];
						sig_B = sig_BR >>4;
						sig_R = sig_BR & 0x0f;
						if( (3*sig_R + 6*sig_G + sig_B) > THR ) TXBuffer[j]=0x00;	//mu0114
						++j;
						sum_B += sig_B;			//mu0114
						sum_R += sig_R;

						sig_GB=TXBuffer[j];
						sig_G = sig_GB >>4;
						sig_B = sig_B + (sig_GB & 0x0f);
						if( (3*sig_R + 6*sig_G + sig_B) > THR ) TXBuffer[j]=0x00;	//mu0114
						++j;
						sum_G += sig_G;
						sum_B += sig_B;

						sig_RG=TXBuffer[j];
						sig_R = sig_R + (sig_RG >>4);
						sig_G = sig_G + (sig_RG & 0x0f);
						if( (3*sig_R + 6*sig_G + sig_B) > THR ) TXBuffer[j]=0x00;	//mu0114
						++j;
						sum_R += sig_R;
						sum_G += sig_G;
				}
			}
/************************ region9 ************************/			
			if(line_counter>=86 && line_counter<128) {
				for(j=128;j<192;){
						sig_GB=TXBuffer[j];
						sig_G = sig_GB >>4;
						sig_B = sig_B + (sig_GB & 0x0f);
						if( (3*sig_R + 6*sig_G + sig_B) > THR ) TXBuffer[j]=0x00;	//mu0114
						++j;
						//sum_G += sig_G;
						//sum_B += sig_B;
						sig_RG=TXBuffer[j];
						sig_R = sig_R + (sig_RG >>4);
						sig_G = sig_G + (sig_RG & 0x0f);
						if( (3*sig_R + 6*sig_G + sig_B) > THR ) TXBuffer[j]=0x00;	//mu0114
						++j;
						//sum_R += sig_R;
						//sum_G += sig_G;

						sig_BR=TXBuffer[j];
						sig_B = sig_BR >>4;
						sig_R = sig_BR & 0x0f;
						if( (3*sig_R + 6*sig_G + sig_B) > THR ) TXBuffer[j]=0x00;	//mu0114
						++j;
						//sum_B += sig_B;			//mu0114
						//sum_R += sig_R;
				}
			}
/*************************region9 end ***************************/

			for(i=0;i<192;i++){					//mu0114 after
			    spi_data(TXBuffer[i]);
			}
		}
			
        INTCONbits.RBIF = 0;            //clear interrupt flag
    }

  if (INTCONbits.INT0IF)
  	{
	  	INTCONbits.INT0IF = 0;					//interrupt flag clear
		if(HREF){					//HREF=H?
			if(pix_counter<256 && line_counter<128){	
				if(pcnt==0){
					sig_BG = PORTD;
				}
				else if(pcnt==1){
					sig_AX = PORTD & 0xf0;
					sig_RG = sig_RX |(sig_BG & 0x0f);
					TXBuffer[addr++]=sig_RG;
				}
				else if(pcnt==2){
					sig_XY = PORTD;
					sig_BR = (sig_BG & 0xf0)|sig_AX>>4;
					TXBuffer[addr++]=sig_BR;
				}
				else if(pcnt==3){
					sig_RX = PORTD & 0xf0;
					sig_GB = (sig_XY<<4)|(sig_XY>>4);
					TXBuffer[addr++]=sig_GB;
				}

				++pcnt;
				if(pcnt>3) pcnt=0;
			}

			++pix_counter;
			//INTCONbits.INT0IF = 0;		//interrupt flag clear//INTF = 0;
		}
   }
}
	
#pragma code
void spi_command(int dat){

   LCD_CS = 0;				// enable chip
   SSPCON1bits.SSPEN = 0;	// shut off hardware SPI allowing direct access to SPI in/out pins
   SPI_DO = 0;				// output low on data out (9th bit low = command)
   SPI_CLK = 1;		
   //Delay1TCY();			// send clock pulse
   //SPI_CLK = 0;		
   SSPCON1bits.SSPEN = 1;	// turn hardware SPI back on
   SPI_CLK=0;				//mu1119
   WriteSPI(dat);			// make PIC do the work for the command byte
   LCD_CS = 1;				// disable

}

void spi_data(int dat){

   LCD_CS = 0;				// enable chip
   SSPCON1bits.SSPEN = 0;	// turn off hardware SPI allowing us direct access to SPI in/out pins
   SPI_DO = 1;				// output high on data out (9th bit high = data)
   SPI_CLK = 1;				
   //Delay1TCY();			// send clock pulse
   //SPI_CLK = 0;			
   SSPCON1bits.SSPEN = 1;	// turn hardware SPI back on
   SPI_CLK=0;				//mu1119
   WriteSPI(dat);			// make PIC do the work for the data byte
   LCD_CS = 1;				// disable
}

void ram_init(void){
		uint i;
		uint j=0;

		for(i=0;i<8;i++){
			TXBuffer[j++]=0xff;			//White
			TXBuffer[j++]=0xff;
			TXBuffer[j++]=0xff;
		}
		for(i=0;i<8;i++){
			TXBuffer[j++]=0xff;			//Yellow
			TXBuffer[j++]=0x0f;
			TXBuffer[j++]=0xf0;
		}
		for(i=0;i<8;i++){
			TXBuffer[j++]=0x0f;			//Cyan
			TXBuffer[j++]=0xf0;
			TXBuffer[j++]=0xff;
		}
		for(i=0;i<8;i++){
			TXBuffer[j++]=0x0f;			//Green
			TXBuffer[j++]=0x00;
			TXBuffer[j++]=0xf0;
		}
		for(i=0;i<8;i++){
			TXBuffer[j++]=0xf0;			//Magenta
			TXBuffer[j++]=0xff;
			TXBuffer[j++]=0x0f;
		}
		for(i=0;i<8;i++){
			TXBuffer[j++]=0xf0;			//Red
			TXBuffer[j++]=0x0f;
			TXBuffer[j++]=0x00;
		}
		for(i=0;i<8;i++){
			TXBuffer[j++]=0x00;			//Blue
			TXBuffer[j++]=0xf0;
			TXBuffer[j++]=0x0f;
		}
		for(i=0;i<8;i++){	
			TXBuffer[j++]=0x00;			//Black
			TXBuffer[j++]=0x00;
			TXBuffer[j++]=0x00;
		}
}

void cam_init(){
	cam_data(REG_COM7, COM7_RESET);			//0x12:COM7(Reset,QCIF,Cbar,RGBformat)
	Delay10KTCYx(200);						//200ms

	c(REG_COM7,COM7_RGB|COM7_FMT_QCIF)		//0x12:COM7	,  0x0C)	//QCIF, RGB

	c(REG_RGB444, R444_ENABLE|R444_RGBX)	//0x8c:RGB 444 control
	c(REG_COM1, 0x40)						//0x04:COM1(CCIR656,AEC)	//0)	//0x40)
	c(REG_COM15, COM15_R01FE|COM15_RGB565)	//0x40:COM15

	c(REG_COM9, 0x38)			//0x14:COM9=max AGC gain ceiling, Freeze AGC/AEC

	//c(0x3d,0xc3)	//(REG_COM13, COM13_GAMMA|COM13_UVSAT|0x2)	//0x3d:COM13
	c(REG_HAECC7,0x94)		//0xaa:Hist AEC/AGC control 7	c(0xAA,0x94)	//AEC algorithm
	
	c(REG_TSLB,0x04)		//0x3a:Neg,UVval,YUYV,window	TSLB_YLAST)		//0x04)	//0x0C)	//0x80)	//0x00)	//0x04)
	c(0x20,0x0f)			//ADCCTR0, A/D range&ref, mu0102

	/******* ringo *********/
	c(REG_COM8,0xdb);		//AGC,AWB OFF,res OK

	//by Mr.Shiono
	c(0x01,0x40)
	c(0x02,0x60)
	c(0x03,0x0a)
	c(0x0c,0x00)
	c(0x0e,0x61)
	c(0x0f,0x4b)
	c(0x15,0x00)
	c(0x16,0x02)
	c(0x17,0x13)
	c(0x18,0x01)
	c(0x19,0x02)
	c(0x1a,0x7a)
	c(0x1e,0x07)
	c(0x21,0x02)
	c(0x22,0x91)
	c(0x29,0x07)
	c(0x32,0xb6)
	c(0x33,0x0b)
	c(0x34,0x11)
	c(0x35,0x0b)
	c(0x37,0x1d)
	c(0x38,0x71)
	c(0x39,0x2a)
	c(0x3b,0x12)
	c(0x3c,0x78)
	c(0x3d,0xc3)
	c(0x3e,0x00)
	c(0x3f,0x00)
	c(0x41,0x08)
	c(0x43,0x0a)
	c(0x44,0xf0)
	c(0x45,0x34)
	c(0x46,0x58)
	c(0x47,0x28)
	c(0x48,0x3a)
	c(0x4b,0x09)
	c(0x4c,0x00)
	c(0x4d,0x40)
	c(0x4e,0x20)
	c(0x4f,0x80)
	c(0x50,0x80)
	c(0x51,0x00)
	c(0x52,0x22)
	c(0x53,0x5e)
	c(0x54,0x80)
	c(0x56,0x40)
	c(0x58,0x9e)
	c(0x59,0x88)
	c(0x5a,0x88)
	c(0x5b,0x44)
	c(0x5c,0x67)
	c(0x5d,0x49)
	c(0x5e,0x0e)
	c(0x69,0x00)
	c(0x6a,0x40)
	c(0x6b,0x0a)
	c(0x6c,0x0a)
	c(0x6d,0x55)
	c(0x6e,0x11)
	c(0x6f,0x9f)
	c(0x70,0x3a)
	c(0x71,0x35)
	c(0x72,0x11)
	c(0x73,0xf0)
	c(0x74,0x10)
	c(0x75,0x05)
	c(0x76,0xe1)
	c(0x77,0x01)
	c(0x78,0x04)
	c(0x79,0x01)
	c(0x8d,0x4f)
	c(0x8e,0x00)
	c(0x8f,0x00)
	c(0x90,0x00)
	c(0x91,0x00)
	c(0x96,0x00)
	c(0x96,0x00)			//?
	c(0x97,0x30)
	c(0x98,0x20)
	c(0x99,0x30)
	c(0x9a,0x00)
	c(0x9a,0x84)			//?
	c(0x9b,0x29)
	c(0x9c,0x03)
	c(0x9d,0x4c)
	c(0x9e,0x3f)
	c(0xa2,0x02)
	c(0xa4,0x88)
	c(0xb0,0x84)
	c(0xb1,0x0c)
	c(0xb2,0x0e)
	c(0xb3,0x82)
	c(0xb8,0x0a)
	c(0xc8,0xf0)
	c(0xc9,0x60)

	c(REG_CLKRC,0xaf)			//PCLK*(1/48)

}

void led_out(unsigned char data){
	LATA = data & 0x3f;
	LATE = data >> 6;
}



