/********************************************************
*  J[OtBbNLCD(132131hbgjpCu
*     iZY-FGD1442701V1p)
*	lcd_Init();		// 
*	lcd_Clear();		// Sʏ
*	lcd_Pixel();		// 1hbg\
*	lcd_Char();		// ANK\
*	lcd_Str();		// ANK\
*	lcd_Line();		// `
*	lcd_Image();		// C[W}\
*********************************************************/
//#include "p24FJ64GA002.h"
#include "p18f46j50.h"
#include "colorlcd_lib24b.h"
#include "HardwareProfile.h"
//#include "ASCII12dot.h"			// ANK@12x12hbg
//#include "font.h"					// ANK@5x7hbg

void delay_us(unsigned short usec);


/********************************
* R}hAf[^o͊֐ 
*********************************/
void lcd_cmd(unsigned char cmnd){
	unsigned int temp;

//	temp = (unsigned int)cmnd;
	TRISD = 0x00;
	LATD = cmnd; 
	LCD_CS = 0;				// CS Low
	LCD_DIO = 0;				// Command
	LCD_WR = 0;				// WR out
	Nop();
	LCD_WR = 1;
	LCD_DIO = 1;
	LCD_CS = 1;				// CS High
	LATD = 0x00;
	TRISD = 0xff;
}


void lcd_data(unsigned char data){
	unsigned int temp;

	temp = (unsigned int)data;
	TRISD = 0x00;
	LATD = data;
	LCD_CS = 0;				// CS Low 
	LCD_DIO = 1;				// Data
	LCD_WR = 0;
	Nop();
	LCD_WR = 1;
	LCD_CS = 1;				// CS High
	TRISD = 0xff;
}


int lcd_data_rd(void)
	{
	unsigned int temp;

	TRISD = 0xff;			// Input
 	LCD_DIO = 1;
	LCD_CS = 0;				// CS Low
	LCD_WR = 1;				// Data
	LCD_RD = 0;
	Nop();
	temp = PORTD;
	LCD_RD = 1;
	LCD_CS = 1;				// CS High
	TRISD = 0xff;
	return temp;
}

/****************************
* LCD֐  
*****************************/
void lcd_Init(void){
	LCD_CS = 1;				// CS High
	LCD_WR = 1;				// WR High
	LCD_RD = 1;				// RD High
	LCD_RST = 1;				// Reset off

	delay_ms(100);
	LCD_RST = 0;				
	delay_ms(100);			// Zbgo
	LCD_RST = 1;
	delay_ms(120);

	// Software reset
	lcd_cmd(SWRESET);
	delay_ms(50);

	lcd_cmd(SLPOUT);			// X[v
	delay_ms(200);			// EFCNAbv҂

	//
	lcd_cmd(VCOM4L);			//
	lcd_data(0x40);
	lcd_data(0x03);
	lcd_data(0x1A);
	//
	lcd_cmd(NVCTR1);
	lcd_data(0x60);
	//
	lcd_cmd(VMOFCTR);
	lcd_data(0x90);
	delay_ms(200);
	//
	lcd_cmd(FRMCTR1);			//Frame Rate in normal mode
	lcd_data(0x04);
	lcd_data(0x25);
	lcd_data(0x18);
	//
	lcd_cmd(FRMCTR2);			//Frame Rate in Idle mode
	lcd_data(0x04);
	lcd_data(0x25);
	lcd_data(0x18);
	//
	lcd_cmd(FRMCTR3);			//Frame Rate in Partial mode
	lcd_data(0x04);
	lcd_data(0x25);
	lcd_data(0x18);
	lcd_data(0x04);
	lcd_data(0x25);
	lcd_data(0x18);
	//
	lcd_cmd(INVCTR);			//Display Inversion normal
	lcd_data(0x03);
	//
	lcd_cmd(DISSET5);			//Gate overlap
	lcd_data(0x15);
	lcd_data(0x02);
	//
	lcd_data(PWCTR1);			//Power control
	lcd_data(0x02);			//VRH=4.7V IB=1uA
	lcd_data(0x70);
	//
	lcd_cmd(PWCTR2);			//Power control
	lcd_data(0x07);			//VGHH=6*VCI
	//
	lcd_cmd(PWCTR3);			//Power control Normal mode
	lcd_data(0x01);			//Small
	lcd_data(0x01);			//BCLK/1 BCLK/2
	//
	lcd_cmd(PWCTR4);			//Power control Idle mode
	lcd_data(0x02);			//Medium
	lcd_data(0x07);			//BCL/4 BCLK/16
	//
	lcd_cmd(PWCTR5);			//Power control Partial mode
	lcd_data(0x02);			//Medeum
	lcd_data(0x04);			//BCLK/2 BCLK/4
	//
	lcd_cmd(PWCTR6);			//Power control Partioal+Idle
	lcd_data(0x11);			//
	lcd_data(0x17);
	//
	lcd_cmd(VMCTR1);			//VCOM control
	lcd_data(0x3C);			//VCOMH=4.0
	lcd_data(0x4F);			//VCOML=-0.525
	//
	lcd_cmd(MADCTL);			//Memory Data Access H refresh
	lcd_data(0x08);
	//
	lcd_cmd(COLMOD);
	lcd_data(0x05);			// Color 16bit mode
	//
	lcd_cmd(GAMCTRP1);		//Gamma correction +pole
	lcd_data(0x06);
	lcd_data(0x0E);
	lcd_data(0x05);
	lcd_data(0x20);
	lcd_data(0x27);
	lcd_data(0x23);
	lcd_data(0x1C);
	lcd_data(0x21);
	lcd_data(0x20);
	lcd_data(0x1C);
	lcd_data(0x26);
	lcd_data(0x2F);
	lcd_data(0x00);
	lcd_data(0x03);
	lcd_data(0x00);
	lcd_data(0x24);
	//
	lcd_cmd(GAMCTRN1);		//Gamma correction -pole
	lcd_data(0x06);
	lcd_data(0x10);
	lcd_data(0x05);
	lcd_data(0x21);
	lcd_data(0x27);
	lcd_data(0x22);
	lcd_data(0x1C);
	lcd_data(0x21);
	lcd_data(0x1F);
	lcd_data(0x1D);
	lcd_data(0x27);
	lcd_data(0x2F);
	lcd_data(0x05);
	lcd_data(0x03);
	lcd_data(0x00);
	lcd_data(0x3F);
	//
	lcd_cmd(DISPON);			// \I
	delay_ms(200);
}
/***************************
* ʏ֐
* pFw肠
****************************/
void lcd_Clear(unsigned short Color){
	short i;

	lcd_cmd(CASET);				// RJnIAhXZbg
	lcd_data(0);
	lcd_data(0);
	lcd_data(0);
	lcd_data(ENDCOL);				// 130
	lcd_cmd(RASET);				// RawJnAIAhXZbg
	lcd_data(0);
	lcd_data(0);
	lcd_data(0);
	lcd_data(ENDPAGE);			// 128
	lcd_cmd(RAMWR);
	// 16bit color mode
	for(i=0; i<(ENDPAGE+1)*(ENDPAGE+1); i++)
		{
		lcd_data(Color >> 8);
		lcd_data(Color);
		}
}
/***********************************
*  PsNZ\֐
*  W(0,0)-(128,128)  
***********************************/


void lcd_Pixel(short Xpos, short Ypos, unsigned short Color)
{
	// if raw>131 or colum >132 then do nothing  

	if((Xpos<=ENDCOL) && (Ypos<=ENDPAGE))
		{
		lcd_cmd(RASET);				// siRAW)AhXZbg
		lcd_data(0);	
		lcd_data(Ypos);
		lcd_data(0);
		lcd_data(Ypos);
		lcd_cmd(CASET);				// iCOLUM)AhXZbg
		lcd_data(0);	
		lcd_data(Xpos);
		lcd_data(0);
		lcd_data(Xpos);
		lcd_cmd(RAMWR);				// 1sNZ
		lcd_data((unsigned char)(Color >> 8));			// 16rbgJ[
		lcd_data((unsigned char)Color);
		}
}


int lcd_Pixel_rd(short Xpos, short Ypos)
{
	// if raw>131 or colum >132 then do nothing  
	int temp1, temp2, temp3;

	if((Xpos<=ENDCOL) && (Ypos<=ENDPAGE))
		{
		lcd_cmd(RASET);				// siRAW)AhXZbg
		lcd_data(0);	
		lcd_data(Ypos);
		lcd_data(0);
		lcd_data(Ypos);
		lcd_cmd(CASET);				// iCOLUM)AhXZbg
		lcd_data(0);	
		lcd_data(Xpos);
		lcd_data(0);
		lcd_data(Xpos);
		lcd_cmd(RAMRD);				// 1sNZǂݏo
		temp1 = lcd_data_rd();		// Dummy
		temp1 = lcd_data_rd();		// R Byte 
		temp2 = lcd_data_rd();		// G Byte
		temp3 = lcd_data_rd();		// B
		temp3 = ((temp1 << 8)& 0xf800) | ((temp2 << 3) & 0x07e0) | ((temp3 >> 3) & 0x001f); // Pack RGB565
		}
	return temp3;
}

/***************************
*  `֐
***************************/


#define	abs(a)	(((a)>0) ? (a) : -(a))

void lcd_Line(short x0, short y0, short x1, short y1, unsigned short Color)
{
	short steep, t;
	short deltax, deltay, error;
	short x, y;
	short ystep;
	
	y0=ENDPAGE-y0;						// YW]
	y1=ENDPAGE-y1;
	/// ̑傫ق߂
	steep = (abs(y1 - y0) > abs(x1 - x0));
	/// A̓ւ
	if(steep){
		t = x0; x0 = y0; y0 = t;
		t = x1; x1 = y1; y1 = t;
	}


	if(x0 > x1) 
		{
		t = x0; 
		x0 = x1; 
		x1 = t;
		t = y0; 
		y0 = y1; 
		y1 = t;
		}
	deltax = x1 - x0;						// XvZ	
	deltay = abs(y1 - y0);
	error = 0;
	y = y0;
	/// XŃXebv̐؂ւ
	if(y0 < y1) 
		ystep = 1; 
	else
		ystep = -1;
	/// _ŕ`
	for(x=x0; x<x1; x++) 
		{
		if(steep) 
			lcd_Pixel(y,x,Color);
		else 
			lcd_Pixel(x,y,Color);
		error += deltay;
		if((error << 1) >= deltax) 
			{
			y += ystep;
			error -= deltax;
			}
		}
}



/**********************************
*  [vx֐@usecP
**********************************/


void delay_us(unsigned short usec)
{
	unsigned short i, Max;
	int j;	

	usec = usec/2;
	for(i=0; i<usec; i++)
	{
	}
}


/**********************************
*  [vx֐@msecP
**********************************/		 


void delay_ms(unsigned short msec)
{
	unsigned short i;
	
	for(i=0; i<msec; i++)
		delay_us(1000);
}


void ram_write(unsigned char x, unsigned char y, unsigned int data)
{
	char temp;
	unsigned int address;
	
	address = (x + (y*128)) * 2;
	temp = (address >> 8) & 0x00ff;		// High Address write
	TRISD = 0;
	LATD = temp;
	MAHWR = 0;
	Nop();
	MAHWR = 1;
	temp = address & 0x00ff;			// Low address write 
	LATD = temp;
	MALWR = 0;
	MALWR = 1;	

	temp = (data >>8) & 0x00ff;			// High Data write 
	LATD = temp;
	RAMCE = 0;
	LCD_WR = 0;
	LCD_WR = 1;

	address = address + 1;
	temp = (address >> 8) & 0x00ff;		// High address write
	LATD = temp;
	MAHWR = 0;
	MAHWR = 1;
	temp = address & 0x00ff;			// Low address write
	LATD = temp;
	MALWR = 0;
	MALWR = 1;	

	temp = data & 0x00ff;				// Low data write
	LATD = temp;
	LCD_WR = 0;
	LCD_WR = 1;
	RAMCE = 1;
	
	LATD = 0;							// Data out
	TRISD = 0xff;
}

unsigned int ram_read(unsigned char x, unsigned char y)
{
	unsigned int temp;
	unsigned int address;
	unsigned int data;

	address = (x + (y*128))* 2;
	temp = (address >> 8) & 0x00ff;		// Hjgh adress write
	TRISD = 0x00;
	LATD = temp;
	MAHWR = 0;
	MAHWR = 1;
	temp = address & 0x00ff;			// Low address write
	LATD = temp;
	MALWR = 0;
	MALWR = 1;	

	TRISD = 0xff;						// High data read
	RAMCE = 0;
	LCD_RD = 0;
	Nop();
	temp = PORTD;
	data = (temp << 8) & 0xff00;
	LCD_RD = 1;
	TRISD = 0x00;		// output

	address = address +1;			
	temp = (address >> 8) & 0x00ff;		// Hjgh address write
	LATD = temp;
	MAHWR = 0;
	MAHWR = 1;
	temp = address & 0x00ff;			// Low address write
	LATD = temp;
	MALWR = 0;
	MALWR = 1;	

	TRISD = 0xff;		//input
	RAMCE = 0;
	LCD_RD = 0;
	Nop();
	data = data | (PORTD & 0x00ff);
	LCD_RD = 1;	
	RAMCE = 1;
	TRISD = 0xff;		// Input	

	return data;
}

/*
void lcd_linedraw(short Xpos, short Ypos, int number, int *lbuf)
{
	// if raw>131 or colum >132 then do nothing  
	int data;
  	int i;

	if((Xpos<=ENDCOL) && (Ypos<=ENDPAGE))
		{
		lcd_cmd(RASET);				// siRAW)AhXZbg
		lcd_data(0);	
		lcd_data(Ypos);
		lcd_data(0);
		lcd_data(Ypos);
		lcd_cmd(CASET);				// iCOLUM)AhXZbg
		lcd_data(0);	
		lcd_data(Xpos);
		lcd_data(0);
		lcd_data(Xpos);
		lcd_cmd(RAMWR);				// 1sNZ
		if(i = 0; i< number; i++)
			{
			data = lbuf[i];
			lcd_data((unsigned char)(data >> 8));			// 16rbgJ[
			lcd_data((unsigned char) data);
			}
		}
}
*/
