
//************************************************
//*
//*   USB User Interface program
//*     Fujitec Laboratory
//*
//************************************************



#include "GenericTypeDefs.h"
#include "Compiler.h"
#include "usb_config.h"
//#include "USB\usb_device.h"
#include "USB\usb.h"
#include "colorlcd_lib24b.h"

#include "HardwareProfile.h"


#pragma udata
extern char cmd, cmd_phase;
extern char CR_detect, send_flag;
extern unsigned char reg_address, reg_data;
extern char rcv_buf[16];
extern char USB_Out_Buffer[CDC_DATA_OUT_EP_SIZE];
extern int cell_avrg[16];
extern int cell_peak[16];
extern int cell_avrg_R[16];
extern int cell_avrg_G[16];
extern int cell_avrg_B[16];

extern int cell_avrg_ref[16];
extern char ermes[8];
extern int c_num;
extern int diff_avrg[16];
extern int diff_peak[16];
extern int threshold, cell_number;
extern int det_mode, ref_mode,ref_set_flag;

int data;
char end_flag;

unsigned int str2bin(void);
void	disp_err_msg1(void);
void ltostring(char digit, unsigned int data, char *buffer);

#pragma code

void reg_setting(void)
{
	int temp;

	switch (cmd_phase)		// Xe[gŏ𕪂
		{
		case 0:
			if (CR_detect == 1)		// ̓obt@1s͂ꂽH
				{
				CR_detect =0;
				switch (rcv_buf[0])		// ̓obt@̂Pڂ̃`FbN
					{
					case '\0':			// ͂Ȃ
						strcpypgm2ram(USB_Out_Buffer, "Command = ");	
						send_flag = 1;
						cmd_phase = 0;		//  	
						break;

					case 's':
						strcpypgm2ram(USB_Out_Buffer, "Set CAM Reg\r\n");
						send_flag = 1;
						cmd_phase = 1;		//  						
						break;

					case 'r':
						strcpypgm2ram(USB_Out_Buffer, "Read CAM Reg\r\n");
						send_flag = 1;
						cmd_phase = 20;		//  						
						break;

					case 't':
						strcpypgm2ram(USB_Out_Buffer, "Threshold (0x00-0xff)\r\n");
						send_flag = 1;
						cmd_phase = 30;		//  						
						break;

					case 'c':
						strcpypgm2ram(USB_Out_Buffer, "Detect CELL Select(FF = ALL)\r\n");
						send_flag = 1;
						cmd_phase = 40;		//  						
						break;

					case 'p':
						strcpypgm2ram(USB_Out_Buffer, "Set Detect Mode\r\n");
						send_flag = 1;
						cmd_phase = 60;		//  						
						break;

					case 'a':
						strcpypgm2ram(USB_Out_Buffer, "Set REF Mode\r\n");
						send_flag = 1;
						cmd_phase = 70;		//  						
						break;

					case 'h':
						strcpypgm2ram(USB_Out_Buffer, "Help\r\n\r\n");
						send_flag = 1;
						cmd_phase = 90;		//  					
						break;	

					case 'd':
						strcpypgm2ram(USB_Out_Buffer, "Show Average data\r\n");
						send_flag = 1;
						cmd_phase = 10;		//  					
						break;	

					case 'z':
						strcpypgm2ram(USB_Out_Buffer, "Set Default Camera settings\r\n");
						send_flag = 1;
						cmd_phase = 80;		//  					
						break;	

			
					default:
						strcpypgm2ram(USB_Out_Buffer, "CMD Error\r\n");						
						send_flag = 1;
						cmd_phase = 0;		//  
						break;
					}
				}
			break;

		case 1:					// start address input
			strcpypgm2ram(USB_Out_Buffer, "Reg address= ");
			send_flag = 1;		
			cmd_phase = 2;
			break;

		case 2:
			if (CR_detect ==1)	// start address calculate
				{
				CR_detect =0;
				if (rcv_buf[0]=='\0')			// No Input ?
					{
					disp_err_msg1();			// Parameter Error!! 	
					cmd_phase = 0;
					}
				else
					{
					reg_address = str2bin();		// Copy Start address 
					strcpypgm2ram(USB_Out_Buffer, "reg data= ");		// Disp End Address
					send_flag = 1;
					cmd_phase = 3;
					}
				}
			break;

		case 3:
			{
			if (CR_detect ==1)			// process End address 
				{
				CR_detect =0;
				if (rcv_buf[0]=='\0')			// No Input ?
					{
					disp_err_msg1();			// Parameter Error!! 	
					cmd_phase = 0;
					}
				else
					{
					reg_data = str2bin();	// Convert end address into binary
					wr_Sensor_Reg(reg_address, reg_data);
					cmd_phase = 0;		
					}
				}
			}
			break;	

		case 10:
			strcpypgm2ram(USB_Out_Buffer, "CELL = ");	// Prompt data input

			for (c_num =0; c_num<16; c_num++)
				{
				ltostring(2, c_num, ermes);	// copy Error Number into disp buffer	
				USB_Out_Buffer[3*c_num+7] = ermes[0];
				USB_Out_Buffer[3*c_num+8] = ermes[1];
				USB_Out_Buffer[3*c_num+9] = ' ';
				}
			USB_Out_Buffer[3*c_num+7] = '\r';
			USB_Out_Buffer[3*c_num+8] = '\n';
			USB_Out_Buffer[3*c_num+9] = '\0';			
			send_flag = 1;
			cmd_phase = 11;		//	
			break;

		case 11:
			strcpypgm2ram(USB_Out_Buffer, "d_avr= ");	// Prompt data input

			for (c_num =0; c_num<16; c_num++)
				{
				data = diff_avrg[c_num];
				ltostring(2, data, ermes);	// copy Error Number into disp buffer	
				USB_Out_Buffer[3*c_num+7] = ermes[0];
				USB_Out_Buffer[3*c_num+8] = ermes[1];
				USB_Out_Buffer[3*c_num+9] = ' ';
				}
			USB_Out_Buffer[3*c_num+7] = '\r';
			USB_Out_Buffer[3*c_num+8] = '\n';
			USB_Out_Buffer[3*c_num+9] = '\0';			
			send_flag = 1;
			cmd_phase = 12;		//	
			break;

		case 12:
			strcpypgm2ram(USB_Out_Buffer, "d_pek= ");	// Prompt data input

			for (c_num =0; c_num<16; c_num++)
				{
				data = diff_peak[c_num];
				ltostring(2, data, ermes);	// copy Error Number into disp buffer	
				USB_Out_Buffer[3*c_num+7] = ermes[0];
				USB_Out_Buffer[3*c_num+8] = ermes[1];
				USB_Out_Buffer[3*c_num+9] = ' ';
				}
			USB_Out_Buffer[3*c_num+7] = '\r';
			USB_Out_Buffer[3*c_num+8] = '\n';
			USB_Out_Buffer[3*c_num+9] = '\0';			
			send_flag = 1;
			cmd_phase = 13;		//	
			break;



		case 13:
			strcpypgm2ram(USB_Out_Buffer, "ave_R= ");	// Prompt data input

			for (c_num =0; c_num<16; c_num++)
				{
				data = cell_avrg_R[c_num];
				ltostring(2, data, ermes);	// copy Error Number into disp buffer	
				USB_Out_Buffer[3*c_num+7] = ermes[0];
				USB_Out_Buffer[3*c_num+8] = ermes[1];
				USB_Out_Buffer[3*c_num+9] = ' ';
				}
			USB_Out_Buffer[3*c_num+7] = '\r';
			USB_Out_Buffer[3*c_num+8] = '\n';
			USB_Out_Buffer[3*c_num+9] = '\0';
			
			send_flag = 1;
			cmd_phase = 14;		//	
			break;


		case 14:
			strcpypgm2ram(USB_Out_Buffer, "ave_G= ");	// Prompt data input

			for (c_num =0; c_num<16; c_num++)
				{
				data = cell_avrg_G[c_num];
				ltostring(2, data, ermes);	// copy Error Number into disp buffer	
				USB_Out_Buffer[3*c_num+7] = ermes[0];
				USB_Out_Buffer[3*c_num+8] = ermes[1];
				USB_Out_Buffer[3*c_num+9] = ' ';
				}
			USB_Out_Buffer[3*c_num+7] = '\r';
			USB_Out_Buffer[3*c_num+8] = '\n';
			USB_Out_Buffer[3*c_num+9] = '\0';
			
			send_flag = 1;
			cmd_phase = 15;		//	
			break;


		case 15:
			strcpypgm2ram(USB_Out_Buffer, "ave_B= ");	// Prompt data input

			for (c_num =0; c_num<16; c_num++)
				{
				data = cell_avrg_B[c_num];
				ltostring(2, data, ermes);	// copy Error Number into disp buffer	
				USB_Out_Buffer[3*c_num+7] = ermes[0];
				USB_Out_Buffer[3*c_num+8] = ermes[1];
				USB_Out_Buffer[3*c_num+9] = ' ';
				}
			USB_Out_Buffer[3*c_num+7] = '\r';
			USB_Out_Buffer[3*c_num+8] = '\n';
			USB_Out_Buffer[3*c_num+9] = '\0';
		
			send_flag = 1;
			cmd_phase = 16;		//	
			break;


		case 16:
			strcpypgm2ram(USB_Out_Buffer, "ave_C= ");	// Prompt data input

			for (c_num =0; c_num<16; c_num++)
				{
				data = cell_avrg[c_num];
				ltostring(2, data, ermes);	// copy Error Number into disp buffer	
				USB_Out_Buffer[3*c_num+7] = ermes[0];
				USB_Out_Buffer[3*c_num+8] = ermes[1];
				USB_Out_Buffer[3*c_num+9] = ' ';
				}

			USB_Out_Buffer[3*c_num+7] = '\r';
			USB_Out_Buffer[3*c_num+8] = '\n';
			USB_Out_Buffer[3*c_num+9] = '\0';
			
			send_flag = 1;
			cmd_phase = 17;		//	
			break;

		case 17:
			strcpypgm2ram(USB_Out_Buffer, "pek_C= ");	// Prompt data input

			for (c_num =0; c_num<16; c_num++)
				{
				data = cell_peak[c_num];
				ltostring(2, data, ermes);	// copy Error Number into disp buffer	
				USB_Out_Buffer[3*c_num+7] = ermes[0];
				USB_Out_Buffer[3*c_num+8] = ermes[1];
				USB_Out_Buffer[3*c_num+9] = ' ';
				}
			USB_Out_Buffer[3*c_num+7] = '\r';
			USB_Out_Buffer[3*c_num+8] = '\n';
			USB_Out_Buffer[3*c_num+9] = '\0';

			send_flag = 1;
			cmd_phase = 0;		//	
			break;


		case 20:					// start address input
			strcpypgm2ram(USB_Out_Buffer, "Reg address= ");
			send_flag = 1;		
			cmd_phase = 21;
			break;

		case 21:
			if (CR_detect ==1)	// start address calculate
				{
				CR_detect =0;
				if (rcv_buf[0]=='\0')			// No Input ?
					{
					disp_err_msg1();			// Parameter Error!! 	
					cmd_phase = 0;
					}
				else
					{
					reg_address = str2bin();		// Copy Start address 
					rd_Sensor_Reg(reg_address, &reg_data);
					ltostring(2, reg_data, ermes);	// copy Error Number into disp buffer	
					strcpypgm2ram(USB_Out_Buffer, "reg data= ");		// Disp End Address
					USB_Out_Buffer[9] = ermes[0];
					USB_Out_Buffer[10] = ermes[1];
					USB_Out_Buffer[11] = ' ';
					USB_Out_Buffer[12] = '\r';
					USB_Out_Buffer[13] = '\n';
					USB_Out_Buffer[14] = '\0';					
					send_flag = 1;
					cmd_phase = 0;
					}
				}
			break;

		case 30:					// start address input
			strcpypgm2ram(USB_Out_Buffer, "LEVEL(00-ff)= ");
			send_flag = 1;		
			cmd_phase = 31;
			break;

		case 31:
			if (CR_detect ==1)	// start address calculate
				{
				CR_detect =0;
				if (rcv_buf[0]=='\0')			// No Input ?
					{
					disp_err_msg1();			// Parameter Error!! 	
					cmd_phase = 0;
					}
				else
					{
					threshold = str2bin();		// Copy Start address 
					send_flag = 1;
					cmd_phase = 0;
					}
				}
			break;

		case 40:					// start address input
			strcpypgm2ram(USB_Out_Buffer, "CELL Number(0-F)= ");
			send_flag = 1;		
			cmd_phase = 41;
			break;

		case 41:
			if (CR_detect ==1)	// start address calculate
				{
				CR_detect =0;
				if (rcv_buf[0]=='\0')			// No Input ?
					{
					disp_err_msg1();			// Parameter Error!! 	
					cmd_phase = 0;
					}
				else
					{
					cell_number = str2bin();		// Copy Start address 
					send_flag = 1;
					cmd_phase = 0;
					}
				}
			break;

		case 60:					// start address input
			strcpypgm2ram(USB_Out_Buffer, "Average:0  Peak:1 = ");
			send_flag = 1;		
			cmd_phase = 61;
			break;

		case 61:
			if (CR_detect ==1)	// start address calculate
				{
				CR_detect =0;
				if (rcv_buf[0]=='\0')			// No Input ?
					{
					disp_err_msg1();			// Parameter Error!! 	
					cmd_phase = 0;
					}
				else
					{
					det_mode = str2bin();		// Copy Start address 
					send_flag = 1;
					cmd_phase = 0;
					}
				}
			break;

		case 70:					// start address input
			strcpypgm2ram(USB_Out_Buffer, "Relative:0  Absolute:1 = ");
			send_flag = 1;		
			cmd_phase = 71;
			break;

		case 71:
			if (CR_detect ==1)	// start address calculate
				{
				CR_detect =0;
				if (rcv_buf[0]=='\0')			// No Input ?
					{
					disp_err_msg1();			// Parameter Error!! 	
					cmd_phase = 0;
					}
				else
					{
					ref_mode = str2bin();		// Copy Start address
					if(ref_mode != 0)
						{
						ref_set_flag = 1;
						}
					send_flag = 1;
					cmd_phase = 0;
					}
				}
			break;

		case 80:					// start address input
			strcpypgm2ram(USB_Out_Buffer, "Type 1 to set");
			send_flag = 1;		
			cmd_phase = 81;
			break;

		case 81:
			if (CR_detect ==1)	// start address calculate
				{
				CR_detect =0;
				if (rcv_buf[0]=='\0')			// No Input ?
					{
					disp_err_msg1();			// Parameter Error!! 	
					cmd_phase = 0;
					}
				else
					{
					temp = str2bin();		// Copy Start address
				
					if(temp == 1)
						{
						Sensor_init();
						}
					send_flag = 1;
					cmd_phase = 0;
					}
				}
			break;


		case 90:				// HELP				
			strcpypgm2ram(USB_Out_Buffer, "Version 1.0 2012/JAN/04  Fujitec Laboratory \r\n\n");
			send_flag = 1;		
			cmd_phase = 91;
			break;

		case 91:					
			strcpypgm2ram(USB_Out_Buffer, "s:Set_Register  r:Read_Register	c:Cell_Number	t:Threshold \r\n");
			send_flag = 1;		
			cmd_phase = 92;
			break;

		case 92:					
			strcpypgm2ram(USB_Out_Buffer, "a:ABS/REL	p:AVERAGE/PEAK	d:Show data	z:Reg_Init \r\n");
			send_flag = 1;		
			cmd_phase = 0;
			break;

		default:
			break;
		}
}



/****************************************************
*  convert number to string                        
*
****************************************************/

void ltostring(char digit, unsigned int data, char *buffer)
{
	unsigned char i, a;
	unsigned int data1;

	data1 = data;
	buffer = buffer + digit;
	*buffer = 0;	
	buffer = buffer -1;
	for (i = 0; i< digit; i++)
		{
		a = data1 & 0x000f;
		data1 = (data1 >> 4); 
		if ((a >= 0) && (a <= 9))
			*(buffer -i) = a + '0';
		else if ((a >= 10) && (a <= 15))
 			*(buffer -i) = a -10 + 'a';
		}
}	
 

unsigned int str2bin(void)
{
	unsigned char length, i, a;
	unsigned int data;

	length = strlen(rcv_buf);
	data = 0;
	for (i=0; i< length; i++)
		{
		a = rcv_buf[length -1 - i];
		if ((a >= '0') && (a <='9'))
			a = a- '0';
		else if ((a >= 'A') && (a <='F'))
			a = a- 'A'+10;
		else if ((a >= 'a') && (a <= 'f'))
			a = a - 'a'+10;
		else
			a = 0;
		switch (i)
			{
			case 0:
				data = a;
				break;
			case 1:
				data = data + a*16;
				break;
			case 2:
				data = data + a*256;
				break;
			case 3:
				data = data + a*4096;
				break;				
			default:
				break;
			}
		}
		return (data);
}

unsigned int str2dec(void)
{
	unsigned char length, i, a;
	unsigned int data;

	length = strlen(rcv_buf);
	data = 0;
	for (i=0; i< length; i++)
		{
		a = rcv_buf[length -1 - i];
		if ((a >= '0') && (a <='9'))
			a = a- '0';
		else
			a = 0;
		switch (i)
			{
			case 0:
				data = a;
				break;
			case 1:
				data = data + a*10;
				break;
			case 2:
				data = data + a*100;
				break;
			case 3:
				data = data + a*1000;
				break;				
			default:
				break;
			}
		}
		return (data);
}
		

// USB Out Buffer clear with space
void USB_OB_clear(void)
{
	char i;
	for (i=0; i<64; i++)
		{
		USB_Out_Buffer[i]=' ';
		}
}

unsigned char hex2dec(char data)
{
	char i;
	while(data >= 10)
		{
		data = data - 10;
		i++;
		}
	return (i*16 + data);
}

void	disp_err_msg1(void)
{
	strcpypgm2ram(USB_Out_Buffer, "Parameter_error !\r\n");		// Disp End Address
	send_flag = 1;
}

