/*
 * Compute blightness value of 16 regions on the sreen
 */
#include <stdio.h>
#include <string.h>
#include "SAMCamera.h"
#include "print.h"

static uint8_t bval[16];
static char wstr[5];

#define	IMG_WIDTH	120
#define	BLOCK_HEIGHT	30
#define	BLOCK_WIDTH	30

void show_blightness(OV_INFO *pinfo, uint8_t *bp)
{
  int i, j, x, y;
  uint8_t *sp, *dp;
  uint8_t minval;
  uint32_t ysum;

  dp = bval;
  for (i = 0; i < 4; i++) {	/* For each row */
    for (j = 0; j < 4; j++) {	/* For each block */
      sp = bp + i * IMG_WIDTH*BLOCK_HEIGHT + j * BLOCK_WIDTH;
      ysum = 0;
      minval = 255;
      for (y = 0; y < BLOCK_HEIGHT; y++) {
        for (x = 0; x < BLOCK_HEIGHT; x++) {
          if (*sp < minval) minval = *sp;
          ysum += *sp++;
        }
        sp += IMG_WIDTH - BLOCK_HEIGHT;
      }
      if (pinfo->direct_mode) {
        *dp++ = minval;
      } else {
        *dp++ = ysum / (BLOCK_WIDTH*BLOCK_HEIGHT); /* Average in this block */
      }
    }
  }

  y = 8;
  sp = bval;
  for (i = 0; i < 4; i++) {
    sprintf(wstr, "%02x %02x", sp[0], sp[1]);
    lcd_string(wstr, FT_NORMAL, 120, y, C_WHITE, C_BLACK);
    sprintf(wstr, "%02x %02x", sp[2], sp[3]);
    lcd_string(wstr, FT_NORMAL, 120, y+8, C_WHITE, C_BLACK);
    y += 30;
    sp += 4;
  }
}
