/*
 * print functions to CDC output stream
 */
#include <stdarg.h>
#include <stdio.h>
#include <string.h>
#include "SAMCamera.h"
#include "usb.h"

#define STRBSIZE  240
static char str_buffer[STRBSIZE+1];

void cons_putchar(char c)
{
  str_buffer[0] = c;
  cdc_write((uint8_t *)str_buffer, 1);
}

void cons_putstring(char *s)
{
  cdc_write((uint8_t *)s, strlen(s));
}

void cons_printf(const char *fmt, ...)
{
  va_list argptr;
  int i;

  va_start(argptr, fmt);
  i = vsnprintf(str_buffer, STRBSIZE, fmt, argptr);
  va_end(argptr);

  cdc_write((uint8_t *)str_buffer, i);
}
