#include "fonts.h"

#define	LCD_WIDTH	160
#define	LCD_HEIGHT	128
#define	BLTBUFSIZE	500

#define	XMIN	0
#define	XMAX	159
#define	XOFFSET	1
#define	YMIN	0
#define	YMAX	127
#define	YOFFSET	2

/* Display positions */
#define X_MTITLE  0
#define Y_MTITLE  16
#define X_MARTIST 0
#define Y_MARTIST 30
#define X_MALBUM  0
#define Y_MALBUM  44
#define X_CHART_L 10
#define Y_CHART_L 60
#define X_CHART_R 10
#define Y_CHART_R 95

/* ST7735 command code definitions */

#define	CMD_NOP		0x00
#define	CMD_SWRESET	0x01	/* Software reset */
#define	CMD_SLPIN	0x10	/* Sleep in & booster off */
#define	CMD_SLPOUT	0x11	/* Sleep out & booster on */
#define	CMD_PTLON	0x12	/* Partial mode on */
#define	CMD_NORON	0x13	/* Normal (Partial off) */
#define	CMD_INVOFF	0x20	/* Display inversion off */
#define	CMD_INVON	0x21	/* Display inversion on */
#define	CMD_GAMSET	0x26	/* Gamma curve select */
#define	CMD_DISPOFF	0x28	/* Display off */
#define	CMD_DISPON	0x29	/* Display on */
#define	CMD_CASET	0x2a	/* Column address set */
#define	CMD_RASET	0x2b	/* Row address set */
#define	CMD_RAMWR	0x2c	/* Memory write */

#define	CMD_MADCTL	0x36	/* Memory data access control */
#define	CMD_COLMOD	0x3a	/* Interface pixel format */

#define	CMD_FRMCTR1	0xb1	/* Frame Rate Control */
#define	CMD_FRMCTR2	0xb2	/* Frame Rate Control (In idle mode) */
#define	CMD_FRMCTR3	0xb3	/* Frame Rate Control (In Partial mode) */
#define	CMD_INVCTR	0xb4	/* Display Inversion Control */
#define	CMD_DISSET5	0xb6	/* Display Function set 5 */
#define	CMD_PWCTR1	0xc0	/* Power Control 1 */
#define	CMD_PWCTR2	0xc1	/* Power Control 2 */
#define	CMD_PWCTR3	0xc2	/* Power Control 3 */
#define	CMD_PWCTR4	0xc3	/* Power Control 4 */
#define	CMD_PWCTR5	0xc4	/* Power Control 5 */
#define	CMD_VMCTR1	0xc5	/* VCOM Control 1 */
#define	CMD_GMCTRP1	0xe0	/* Gamma (+) Correction Characteristics */
#define	CMD_GMCTRN1	0xe1	/* Gamma (-) Correction Characteristics */
#define	CMD_PWCTR6	0xfc	/* Power Control 6 */

#define	C_WHITE		0xffff
#define	C_RED		0xf800
#define	C_GREEN		0x07e0
#define	C_BLUE		0x001f
#define	C_BLACK		0x0000
#define	C_YELLOW	0xffe0
#define	C_PURPLE	0xf81f
#define	C_LBLUE		0x067f		/* Light blue */
#define	C_GRAY		0x8410

void lcd_init(int flag);
void lcd_string(char *string, const uint8_t *font, int x, int y, int fgcolor, int bgcolor);
void lcd_vert_string(char *string, const uint8_t *font, int x, int y, int fgcolor, int bgcolor);
void lcd_fill_rect(int x, int y, int width, int height, int color);
void lcd_copy_line(uint8_t *bp, int ypos);
void lcd_copy_frame(uint8_t *bp, int width, int height);
void lcd_copy_yframe(uint8_t *bp, OV_INFO *pinfo);
void lcd_copy_yframe_grid(uint8_t *bp, OV_INFO *pinfo);
void lcd_draw_guide(void);
void lcd_vert_line(int line, int val);
void lcd_show_title(char *title);
