unsigned char address  = 0;    // I2C address
unsigned char data = 0;   // I2C data
unsigned char reg_01blue;
unsigned char reg_02red;
unsigned char reg_05bave;
unsigned char reg_06gbave;
unsigned char reg_08rave;

int reg_00gain;
int reg_03vref;
int reg_04com1;
int reg_07aechh;
int reg_10aech;
int cnv;

char str[6];
int shut, gain;
float lumi, lumi5,lumit ,ctempr, ctempr5,ctempt;
float aec,agc;
float r, g, b ;
float rg, bg;
float y;
int textcol = 0xffff ;
int menucol = 0x07ff ;
int ystep = 8;
int xstep = 16;
int aestep = 1;
int count= 1 ;
float ctempold[5],lumiold[5] ;

#include <Wire.h>
#include <SoftwareSerial.h>
SoftwareSerial mySerial(2, 3);

void setup()
{
  const unsigned char PROGMEM speed[]= {
    0x55 ,0x05 ,0x8B ,0x00 ,0x01 ,0xC2, 0x00, 0x4E, 0xAA };

  // LCD Reset
  int rstpin= 4;
  pinMode(rstpin,OUTPUT);
  digitalWrite(rstpin, LOW);
  delay(500);                  
  digitalWrite(rstpin, HIGH);    
  delay(100);

  //I2C start
  Wire.begin();
  
  //Serial Start 
  Serial.begin(9600);
  mySerial.begin(9600);
  delay(100);

  //Change LCD Speed 9600 to 115200bps
  mySerial.write( speed, 9 );
  delay(100);
  mySerial.begin(115200);
  delay(100);
  
  lcdbright(100);
  delay(100);
  lcdcls();
  
  OV7670init();
  
  lcdtextback(1, 0);
     PrintMenu()  ;
    ystep = 16;
    xstep = 8;
}

void loop()
{
  delay(10);
 // AE start  
   // read register
   reg_00gain  = readreg(0x00);
   reg_01blue  = readreg(0x01);
   reg_02red   = readreg(0x02);
   reg_03vref  = readreg(0x03);
   reg_04com1  = readreg(0x04);
   reg_05bave  = readreg(0x05);
   reg_06gbave = readreg(0x06);
   reg_07aechh = readreg(0x07);
   reg_08rave  = readreg(0x08);
   reg_10aech  = readreg(0x10);
   
   gain = ( (reg_03vref & 0xC0) <<2 | reg_00gain )     ;
   shut =  ((reg_07aechh & 0x3F) << 10) | ( reg_10aech << 2) | (reg_04com1 & 0x03) ;
     
   g = reg_06gbave;
  
   if ( g > 100) {
     // bright
      if (g >200) {aestep =10;}
      if (g >150 & g <=200) {aestep =5;}
      if (g >120 & g <=150) {aestep =2;}
      if (g >100 & g <=120) {aestep =1;}
    
      if (gain > 0) {
          gain = gain - aestep ;
          if( gain < 0 ) { gain = 0;}
      } else {
          shut = shut - aestep ;
        if( shut < 1 ) { shut = 1;}
      }
      
   } else {
     // dark
      if (g < 50) {aestep =10;}
      if (g < 80 & g >=50) {aestep =2;}
      if (g < 100 & g >=80) {aestep =1;}
      
      if (gain >= 0 & shut == 509 ) {
          gain = gain + aestep ;
          if( gain > 255 ) { gain = 255;}
      } else {
          shut = shut + aestep ;
        if( shut > 509 ) { shut = 509;}
      }
   }
      reg_10aech = (shut >> 2) & 0xFF ;
      reg_04com1 = shut & 0x03 ;
      writereg (0x10, reg_10aech);
      writereg (0x04, reg_04com1);
      reg_00gain = gain & 0xFF ;
     writereg (0x00, reg_00gain);
 
    agc = gain; 
    aec = shut;
  
   //calculate AEC/AGC  
  r = reg_08rave;
  g = reg_06gbave;
  b = reg_05bave ;
  
  rg = r/g;
  bg = b/g;
  
  // calculate luminance
  if (aec < 509) {
      //use AEC
 lumit = 107015 * ( 1 / aec) - 55.493;
     
  } else {
     //use AGC
 
 lumit = 1/(0.0005 * agc + 0.0047)   ;
    
  }
 
  // calculate Color temp.
  // use R/G
  
  if (rg  < 0.7538) {
      ctempt = -12190 * rg + 13549 ;
    } else {
     ctempt = -2821.3 * rg  + 6486.7 ;
    }
 
 lumi5=0;
 ctempr5=0;
 lumiold[1] = lumit ;
 ctempold[1] = ctempt ;
 
 for(int i= 1; i < 6 ;i++ ) {
   lumi5 = lumi5 + lumiold[i] ;
   ctempr5 = ctempr5 + ctempold[i] ;
 }

 for(int i= 1; i < 5 ;i++ ) {
   lumiold[i+1]= lumiold[i] ;
   ctempold[i+1]= ctempold[i] ;
 }
 
 lumi = lumit ;
 ctempr = ctempt;
 
  //output for serial
    Serial.print("count/aec/agc/R/G/B/lumi/ctemp,");
    Serial.print(count);
    Serial.print(",");    
    Serial.print(aec);
    Serial.print(",");
    Serial.print(agc);
    Serial.print(","); 
    Serial.print(reg_08rave,DEC);
    Serial.print(","); 
    Serial.print(reg_06gbave,DEC);
    Serial.print(","); 
    Serial.print(reg_05bave,DEC);
    Serial.print(","); 
    Serial.print(lumi,DEC);
    Serial.print(","); 
    Serial.println(ctempr,DEC);

   count++ ;
   
   snprintf (str , 8 , "%4d", int(aec));
   lcdputs(str  ,6 * xstep ,ystep * 0);
   snprintf (str , 8 , "%4d", int(agc));
   lcdputs(str  ,6 * xstep,ystep * 1);
   snprintf (str , 8 , "%6d", int(lumi));
   lcdputs(str  ,6 * xstep,ystep * 2);
   snprintf (str , 8 , "%4d", int(reg_08rave));
   lcdputs(str  ,6 * xstep,ystep * 4);
   snprintf (str , 8 , "%4d", int(reg_06gbave));
   lcdputs(str  ,6 * xstep,ystep * 5);
   snprintf (str , 8 , "%4d", int(reg_05bave));
   lcdputs(str  ,6 * xstep,ystep * 6);
   dtostrf(rg , 6 ,3, str);
   lcdputs(str  ,6 * xstep,ystep * 7);
   dtostrf(bg , 6 ,3, str);
   lcdputs(str  ,6 * xstep,ystep * 8);
   snprintf (str , 8 , "%6d", int(ctempr));
   lcdputs(str  ,6 * xstep,ystep * 9);
   
    delay(10);
   
}

  

void lcdcls()
{
//  lcdcolorb(0);
  const unsigned char PROGMEM cls[]=
  {    0x55 ,0x02 ,0x80 ,0x55 ,0xd5 ,0xAA      };
  mySerial.write( cls, 6 );
  delay(200);
}
void lcdbright(int bright)
{
  unsigned char back[]=
  {    0x55 ,0x03 ,0x89 ,0x01 ,0x2C ,0xB6 ,0xAA   };

  back[3] = bright >> 8;
  back[4] = bright & 0xFF;
  back[5] = back[2]+ back[3]+ back[4];

  mySerial.write( back, 7 );
  delay(200);
}

void lcdputs( char data[98],int x,int y)
{
  unsigned char s=0;
  unsigned char x0H;
  unsigned char x0L;
  unsigned char y0H;
  unsigned char y0L;
  unsigned char datalen;
  x0H = x >> 8;
  x0L = x & 0xFF;
  y0H = y >> 8;
  y0L = y & 0xFF;
  datalen = strlen(data)+5;
  mySerial.write(0x55);
  mySerial.write(datalen);
  mySerial.write(0x0B);  // command ASCII Print
  mySerial.write(x0H);   //x upper 8bit
  mySerial.write(x0L);   //x low 8bit
  mySerial.write(y0H);   //y upper 8bit
  mySerial.write(y0L);   //y low 8bit
  for(int a=0;a<strlen(data);a++)
  {
    mySerial.write(data[a]);
    s = s+data[a];
  }
  s = s+x0H+x0L+y0H+y0L+0x0B;
  mySerial.write(s);//sumcheck
  mySerial.write(0xAA);
}

void lcdcolor(unsigned char r, unsigned char g,unsigned char b)
{
  int rgb;
  rgb = (r & 0xF8) << 8;        /* RRRRR----------- */
  rgb |= (g & 0xFC) << 3;       /* -----GGGGGG----- */
  rgb |= b >> 3;                /* -----------BBBBB */
  lcdcolorb( rgb);
}

void lcdcolorb( int rgb)
{
  unsigned char c1;
  unsigned char c2;
  unsigned char sum;
  c1=(rgb >> 8) & 0xff;
  c2=(rgb & 0xff);
  sum=c1+c2+0x84;
  mySerial.write(0x55);
  mySerial.write(0x03);
  mySerial.write(0x84);
  mySerial.write(c1);
  mySerial.write(c2);
  mySerial.write(sum);
  mySerial.write(0xAA);
}

void lcdtextset(int siz,  int rgb)
{
  unsigned char sum;
  unsigned char data[4];
  data[0]= siz >> 8;//x upper 8bit
  data[1]= siz & 0xFF;//x low 8bit
  data[2]= rgb >> 8; //y upper 8bit
  data[3]= rgb & 0xFF; //y low 8bit
  sum=data[0]+data[1]+data[2]+data[3]+0x81;
  mySerial.write(0x55);
  mySerial.write(0x05);
  mySerial.write(0x81);
  mySerial.write(data[0]);
  mySerial.write(data[1]);
  mySerial.write(data[2]);
  mySerial.write(data[3]);
  mySerial.write(sum);
  mySerial.write(0xAA);
}

void lcdtextback(int mode,int rgb) {
  unsigned char sum;
  unsigned char data[3];
  data[0]= mode ;
  data[1]=(rgb >> 8) & 0xff;
  data[2]=(rgb & 0xff);
  sum=data[0]+data[1]+data[2]+0x85;
  mySerial.write(0x55);
  mySerial.write(0x04);
  mySerial.write(0x85);
  mySerial.write(data[0]);
  mySerial.write(data[1]);
  mySerial.write(data[2]);
  mySerial.write(sum);
  mySerial.write(0xAA);
}

void PrintMenu(void)
{
//  Serial.println(" OV7640 reg reader");
lcdtextset(2, menucol);
 ystep = 16;

lcdputs("AEC : " ,0,ystep * 0);
lcdputs("AGC : " ,0,ystep * 1);
lcdputs("Lumi: " ,0,ystep * 2);
lcdputs("Rave: " ,0,ystep * 4);
lcdputs("Gave: " ,0,ystep * 5);
lcdputs("Bave: " ,0,ystep * 6);
lcdputs("R/G : " ,0,ystep * 7);
lcdputs("B/G : " ,0,ystep * 8);
lcdputs("CTmp: " ,0,ystep * 9);

  lcdtextset(2, textcol);
 Serial.println(" ");
 Serial.println("boot");
 Serial.println(" ");
 Serial.println("Count,AEC,AGC,Rave,Gave,Bave,");
}

unsigned char readreg(unsigned char address)
{
  unsigned char data;
    Wire.beginTransmission(0x21); // write 0x42 read 0x43
    Wire.write(address);        // sends address
    Wire.endTransmission();    // stop transmitting
    Wire.requestFrom(0x21, 1);
    data = Wire.read();
    return data;
}

void writereg(unsigned char adrs, unsigned char data)
{
    Wire.beginTransmission(0x21); // write 0x42 read 0x43
    Wire.write(adrs);        // sends address
    Wire.write(data);              // sends data  
   Wire.endTransmission();    // stop transmitting
}

void setae(int gain, int shut)
{
unsigned char aecl,aech,agcl,agch ;
    agch = gain >> 8;
    agcl = gain & 0xFF;
    aech = shut >> 8;
    aecl = shut & 0xFF;
}

void OV7670init(void)
{
int i=0;
char str[5];
const char PROGMEM ov7670initdata[][2] = 
{
{0x01,0x40},{0x02,0x60},{0x03,0x0a},{0x0c,0x00},{0x0e,0x61},{0x0f,0x4b},{0x15,0x00},{0x16,0x02},
{0x17,0x13},{0x18,0x01},{0x19,0x02},{0x1a,0x7a},{0x1e,0x07},{0x21,0x02},{0x22,0x91},{0x29,0x07},
{0x32,0xb6},{0x33,0x0b},{0x34,0x11},{0x35,0x0b},{0x37,0x1d},{0x38,0x71},{0x39,0x2a},{0x3b,0x12},
{0x3c,0x78},{0x3d,0xc3},{0x3e,0x00},{0x3f,0x00},{0x41,0x08},{0x41,0x38},{0x43,0x0a},{0x44,0xf0},
{0x45,0x34},{0x46,0x58},{0x47,0x28},{0x48,0x3a},{0x4b,0x09},{0x4c,0x00},{0x4d,0x40},{0x4e,0x20},
{0x4f,0x80},{0x50,0x80},{0x51,0x00},{0x52,0x22},{0x53,0x5e},{0x54,0x80},{0x56,0x40},{0x58,0x9e},
{0x59,0x88},{0x5a,0x88},{0x5b,0x44},{0x5c,0x67},{0x5d,0x49},{0x5e,0x0e},{0x69,0x00},{0x6a,0x40},
{0x6b,0x0a},{0x6c,0x0a},{0x6d,0x55},{0x6e,0x11},{0x6f,0x9f},{0x70,0x3a},{0x71,0x35},{0x72,0x11},
{0x73,0xf0},{0x74,0x10},{0x75,0x05},{0x76,0xe1},{0x77,0x01},{0x78,0x04},{0x79,0x01},{0x8d,0x4f},
{0x8e,0x00},{0x8f,0x00},{0x90,0x00},{0x91,0x00},{0x96,0x00},{0x96,0x00},{0x97,0x30},{0x98,0x20},
{0x99,0x30},{0x9a,0x00},{0x9a,0x84},{0x9b,0x29},{0x9c,0x03},{0x9d,0x4c},{0x9e,0x3f},{0xa2,0x02},
{0xa4,0x88},{0xb0,0x84},{0xb1,0x0c},{0xb2,0x0e},{0xb3,0x82},{0xb8,0x0a},{0xc8,0xf0},{0xc9,0x60}
// end of marker
};
  
for (int i=0; i <= 96; i++){
  writereg(ov7670initdata[i][0],ov7670initdata[i][1]); 
   delay(10);

    snprintf (str , 5 , "%d", i);
    lcdputs(str ,0,0);
}

writereg(0x12,0x04); // COM7 RGB
writereg(0x13,0x88); // COM8 AGC,AWB,AEC disable
writereg(0x13,0x8D); // COM8 AWB disable

writereg(0x01,0x60); // BLUE:0x60
writereg(0x02,0x40); // RED: 0x40
writereg(0x00,0x00); // GAIN: 00
writereg(0x04,0x01); // COM1 AEC[1:0] = 01
writereg(0x10,0x7F); // AECH= 7F AEC[9:2] = 7F1

  lcdputs("done",0,16);

}


